/*
 * Pig
 * ICFP 2005
 * Drunk Sed Team
 * http://sed.free.fr/icfp2005
 */

#ifndef _STRATEGY_H_
#define _STRATEGY_H_

/* for the target_list, type of nodes */
#define DELETED		-1
#define ROBBER_POSITION 0
#define MY_GUESS        1
#define BANK            2
#define AROUND_GUESS    3

/* node, type */
void add_target(int, int);
void smell(int);
void around(int);

void init_distances(void);
void inform(void);
void plan(void);
void vote(void);
void move(void);

typedef unsigned char node_type;

#define FOOT    1
#define CAR     2

#define MAX_EDGES (10000*2)
#define MAX_NODES 256
#define NB_BANKS 6
#define NB_COPS 5

#include "vars.h"

extern char *robber_name;
extern int world;
extern variables vars;
extern variables cops_names;
extern int nb_nodes;
extern node_type edges[MAX_NODES][MAX_NODES];
extern node_type hq;
extern node_type bank[NB_BANKS];
extern int money[NB_BANKS];
extern int my_money;
/* if cop[i] > 0, cop by foot, if cop[i] < 0, cop by car */
extern int cop[NB_COPS];

#endif /* _STRATEGY_H_ */
