/*
 * A mini transition relation postfix reader
 * ---
 * January 2002
 * to my angel
 */

#ifndef _VARS_H_
#define _VARS_H_

#include "strings.h"

#define VARIABLE_TYPE_NO_TYPE	0
#define VARIABLE_TYPE_CURRENT	0x01
#define VARIABLE_TYPE_NEXT	0x02
#define VARIABLE_TYPE_INPUT	0x04
#define VARIABLE_TYPE_OUTPUT	0x08
#define VARIABLE_TYPE_CTL	0x10	/* the var appears in the property to check */

typedef int variable;

typedef struct {
  int type;
  sid name;
  void *bdd1;
  void *bdd2;
  variable canonik_variable;	/* bmc needs that */

  /* data for partitioned transition relation */
  /* trans_fun is only defined for next state variables */
  void *trans_fun;
  /* a tag - used when generating the order for the partition to make the relational product */
  int tag;
} _variable;

typedef struct {
  strings strings;
  _variable *data;
  int size;
  int maxsize;
} variables;

#define NO_VARIABLE	(-1)

#define variable_is_output(v, x) ((v).data[x].type & VARIABLE_TYPE_OUTPUT)

int init_vars(variables *);
void free_vars(variables *);

char *get_variable_name(variables *, variable);

variable get_variable(variables *, char *);

void *get_variable_bddvar(variables *, variable);
void set_variable_bddvar(variables *, variable, void *);

void *get_variable_bdd(variables *, variable);
void set_variable_bdd(variables *, variable, void *);

void set_variable_type(variables *, variable, int);
void add_variable_type(variables *, variable, int);
int get_variable_type(variables *, variable);

void set_variable_canon(variables *, variable, variable);
variable get_variable_canon(variables *, variable);

void *get_variable_trans_fun(variables *, variable);
void set_variable_trans_fun(variables *, variable, void *);

int get_variable_tag(variables *, variable);
void set_variable_tag(variables *, variable, int);

int new_variable(variables *, char *);
int new_or_get_variable(variables *, char *, int *);

#endif /* _VARS_H_ */
