/*
 * Some verbosity facilities
 *---
 * to my angel
 * public domain
 * march 2002
 */

#ifndef _VERBOSE_H_
#define _VERBOSE_H_

#include "strings.h"

typedef struct {
  strings s;
} verbose;

/* if not in debug mode, print simply do nothing (if the compiler is c99) */
#if __STDC_VERSION__ && __STDC_VERSION__ >= 199901L

#ifdef DEBUG

#include <stdio.h>

int init_verbose(verbose *);
void free_verbose(verbose *);

int verbose_register(verbose *, char *);
int verbose_print(char *, FILE *, char *, ...);
int verbose_on(char *);

#define print(...) verbose_print(__VA_ARGS__)

#else

#define init_verbose(...) (0)
#define free_verbose(...) /* */

#define verbose_register(...) (0)
#define verbose_print(...) (0)
#define verbose_on(...) (0)

#define print(...) /* do nothing */

#endif

/* if not c99 compiler, well, simply call it all the time */
#else /* __STDC_VERSION__ && __STD_C_VERSION__ >= 199901L */

#include <stdio.h>

int init_verbose(verbose *);
void free_verbose(verbose *);

int verbose_register(verbose *, char *);
int verbose_print(char *, FILE *, char *, ...);
int verbose_on(char *);

#define print verbose_print

#endif /* __STDC_VERSION__ && __STD_C_VERSION__ >= 199901L */

#endif /* _VERBOSE_H_ */
